*=======================================================
use "数据集.dta", clear
xtset id year

quietly:reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
predict x_hat
gen x_hatxNatResRent = x_hat * NatResRent
gen x_hatxCoalOilRent = x_hat * CoalOilRent
gen x_hatxHumCap4 = x_hat * HumCap4
gen x_hatxHumCap5 = x_hat * HumCap5
gen x_hatxInnov0 = x_hat * Innov0
gen x_hatxInnov1 = x_hat * Innov1
gen x_hatxIndStruct1 = x_hat * IndStruct1
gen x_hatxIndStruct2 = x_hat * IndStruct2
gen x_hatxIntcoop1 = x_hat * Intcoop1
gen x_hatxIntcoop2 = x_hat * Intcoop2

*===============================================================================

///表1 OLS估计：地缘政治风险对国家碳排放的影响
quietly:reghdfe cepc gpr, vce(robust)
estadd local Controls "No"
estadd local Year "No"
estadd local Country "No"
est sto m1
quietly:reghdfe cepc L1.gpr UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m2
quietly:reghdfe cepc L2.gpr UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m3
quietly:reghdfe cepc gpr, absorb(year id) vce(robust)
estadd local Controls "No"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m4
quietly:reghdfe cepc gpr UrbanRate Pop IndStruct OpenFT GrpcGDP, vce(robust)
estadd local Controls "Yes"
estadd local Year "No"
estadd local Country "No"
est sto m5
quietly:reghdfe cepc gpr UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m6
esttab m1 m2 m3 m4 m5 m6, b(%12.4f) se(%12.4f) nogap compress s(Controls Year Country N) star (* 0.1 ** 0.05 *** 0.01)

*===============================================================================

///表2 基准模型的工具变量2阶段最小二乘估计结果
//表2（1）列
quietly:reghdfe gpr DomRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m1
//表2（2）列
quietly:xtivreg2 cepc (gpr = DomRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m2
//表2（3）列
quietly:reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m3
//表2（4）列
quietly:xtivreg2 cepc (gpr = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m4
//表2（5）列
quietly:reghdfe gpr RefNum UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m5
//表2（6）列
quietly:xtivreg2 cepc (gpr = RefNum) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m6
esttab m1 m2 m3 m4 m5 m6, b(%12.4f) se(%12.4f) nogap compress s(Controls Year Country N) star (* 0.1 ** 0.05 *** 0.01) keep(DomRelConfl IntRelConfl RefNum gpr)

*===============================================================================

///表3  渠道检验：能源消费结构效应 
//表3（1）-（2）列
quietly:reghdfe EnConStruct_1 gpr UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m1
quietly:xtivreg2 EnConStruct_1 (gpr = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m2
//表3（3）-（4）列
quietly:reghdfe EnConStruct_2 gpr UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m3
quietly:xtivreg2 EnConStruct_2 (gpr = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m4
//表3（5）-（6）列
quietly:reghdfe EnConStruct_3 gpr UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m5
quietly:xtivreg2 EnConStruct_3 (gpr = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m6
esttab m1 m2 m3 m4 m5 m6, b(%12.4f) se(%12.4f) nogap compress s(Controls Year Country N) star (* 0.1 ** 0.05 *** 0.01) drop(UrbanRate Pop IndStruct OpenFT GrpcGDP _cons year2 year3 year4 year5 year6 year7 year8 year9 year10 year11 year12 year13 year14 year15 year16 year17 year18 year19 year20 year21 year22 year23 year24 year25 year26 year27 year28 year29 year30 year31 year32)

*===============================================================================

///表4  渠道检验：能源消费总量与技术溢出阻滞效应 
//表4（1）-（2）列
quietly:reghdfe TotEnCon gpr UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m1
quietly:xtivreg2 TotEnCon (gpr = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m2
//表4（3）-（4）列
quietly:reghdfe TechSpillEff_FDI gpr UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m3
quietly:xtivreg2 TechSpillEff_FDI (gpr = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m4
//表4（5）-（6）列
quietly:reghdfe TechSpillEff_Trade gpr UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m5
quietly:xtivreg2 TechSpillEff_Trade (gpr = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m6
esttab m1 m2 m3 m4 m5 m6, b(%12.4f) se(%12.4f) nogap compress s(Controls Year Country N) star (* 0.1 ** 0.05 *** 0.01) drop(UrbanRate Pop IndStruct OpenFT GrpcGDP _cons year2 year3 year4 year5 year6 year7 year8 year9 year10 year11 year12 year13 year14 year15 year16 year17 year18 year19 year20 year21 year22 year23 year24 year25 year26 year27 year28 year29 year30 year31 year32)

*===============================================================================

///表5  环境领域"资源诅咒"效应检验
//表5（1）列
quietly:reghdfe cepc gpr gprxNatResRent UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m1

//表5（2）列
* Raw 2nd Stage Regression
quietly:reghdfe cepc x_hat x_hatxNatResRent UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
matrix bmatrix = e(b)
matrix Vmatrix = e(V)
* Manually Adjusted SE's
quietly:reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
predict double ghat, xbd
gen gc = gpr * NatResRent
gen ghc = ghat * NatResRent
quietly:reghdfe cepc ghat ghc UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
predict double res, residual
gen res_c = res + (_b[ghat]*ghat-_b[ghat]*gpr) + (_b[ghc]*ghc-_b[ghc]*gc)
replace res_c = res_c^2
quietly:su res_c
scalar realmse = r(mean)*r(N)/e(df_r)
matrix Vmatrix = Vmatrix * realmse / e(rmse)^2
ereturn post bmatrix Vmatrix, noclear
ereturn display
drop ghat gc ghc res res_c 
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m2

//表5（3）列
quietly:reghdfe cepc gpr gprxCoalOilRent UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m3

//表5（4）列
* Raw 2nd Stage Regression
quietly:reghdfe cepc x_hat x_hatxCoalOilRent UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
matrix bmatrix = e(b)
matrix Vmatrix = e(V)
* Manually Adjusted SE's
quietly:reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
predict double ghat, xbd
gen gc = gpr * CoalOilRent
gen ghc = ghat * CoalOilRent
quietly: reghdfe cepc ghat ghc UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
predict double res, residual
gen res_c = res + (_b[ghat]*ghat-_b[ghat]*gpr) + (_b[ghc]*ghc-_b[ghc]*gc)
replace res_c = res_c^2
quietly:su res_c
scalar realmse = r(mean)*r(N)/e(df_r)
matrix Vmatrix = Vmatrix * realmse / e(rmse)^2
ereturn post bmatrix Vmatrix, noclear
ereturn display
drop ghat gc ghc res res_c 
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m4

esttab m1 m2 m3 m4, b(%12.4f) se(%12.4f) nogap compress s(Controls Year Country N) star (* 0.1 ** 0.05 *** 0.01) drop(UrbanRate Pop IndStruct OpenFT GrpcGDP _cons )

*===============================================================================

///表6  地缘政治风险背景下的减碳路径检验I
//表6（1）列
quietly:reghdfe cepc gpr gprxHumCap4 UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m1

//表6（2）列
* Raw 2nd Stage Regression
quietly:reghdfe cepc x_hat x_hatxHumCap4 UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
matrix bmatrix = e(b)
matrix Vmatrix = e(V)
* Manually Adjusted SE's
quietly:reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
predict double ghat, xbd
gen gc = gpr * HumCap4
gen ghc = ghat * HumCap4
quietly: reghdfe cepc ghat ghc UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
predict double res, residual
gen res_c = res + (_b[ghat]*ghat-_b[ghat]*gpr) + (_b[ghc]*ghc-_b[ghc]*gc)
replace res_c = res_c^2
quietly:su res_c
scalar realmse = r(mean)*r(N)/e(df_r)
matrix Vmatrix = Vmatrix * realmse / e(rmse)^2
ereturn post bmatrix Vmatrix, noclear
ereturn display
drop ghat gc ghc res res_c 
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m2

//表6（3）列
quietly:reghdfe cepc gpr gprxInnov0 UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m3

//表6（4）列
* Raw 2nd Stage Regression
quietly:reghdfe cepc x_hat x_hatxInnov0 UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
matrix bmatrix = e(b)
matrix Vmatrix = e(V)
* Manually Adjusted SE's
quietly:reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
predict double ghat, xbd
gen gc = gpr * Innov0
gen ghc = ghat * Innov0
quietly: reghdfe cepc ghat ghc UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
predict double res, residual
gen res_c = res + (_b[ghat]*ghat-_b[ghat]*gpr) + (_b[ghc]*ghc-_b[ghc]*gc)
replace res_c = res_c^2
quietly:su res_c
scalar realmse = r(mean)*r(N)/e(df_r)
matrix Vmatrix = Vmatrix * realmse / e(rmse)^2
ereturn post bmatrix Vmatrix, noclear
ereturn display
drop ghat gc ghc res res_c 
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m4

esttab m1 m2 m3 m4, b(%12.4f) se(%12.4f) nogap compress s(Controls Year Country N) star (* 0.1 ** 0.05 *** 0.01) drop(UrbanRate Pop IndStruct OpenFT GrpcGDP _cons )

*===============================================================================

///表7  地缘政治风险背景下的减碳路径检验II
//表7（1）列
quietly:reghdfe cepc gpr gprxIndStruct1 UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m1

//表7（2）列
* Raw 2nd Stage Regression
quietly:reghdfe cepc x_hat x_hatxIndStruct1 UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
matrix bmatrix = e(b)
matrix Vmatrix = e(V)
* Manually Adjusted SE's
quietly:reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
predict double ghat, xbd
gen gc = gpr * IndStruct1
gen ghc = ghat * IndStruct1
quietly: reghdfe cepc ghat ghc UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
predict double res, residual
gen res_c = res + (_b[ghat]*ghat-_b[ghat]*gpr) + (_b[ghc]*ghc-_b[ghc]*gc)
replace res_c = res_c^2
quietly:su res_c
scalar realmse = r(mean)*r(N)/e(df_r)
matrix Vmatrix = Vmatrix * realmse / e(rmse)^2
ereturn post bmatrix Vmatrix, noclear
ereturn display
drop ghat gc ghc res res_c 
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m2

//表7（3）列
quietly:reghdfe cepc gpr gprxIntcoop1 UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m3

//表7（4）列
* Raw 2nd Stage Regression
quietly:reghdfe cepc x_hat x_hatxIntcoop1 UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
matrix bmatrix = e(b)
matrix Vmatrix = e(V)
* Manually Adjusted SE's
quietly:reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
predict double ghat, xbd
gen gc = gpr * Intcoop1
gen ghc = ghat * Intcoop1
quietly: reghdfe cepc ghat ghc UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
predict double res, residual
gen res_c = res + (_b[ghat]*ghat-_b[ghat]*gpr) + (_b[ghc]*ghc-_b[ghc]*gc)
replace res_c = res_c^2
quietly:su res_c
scalar realmse = r(mean)*r(N)/e(df_r)
matrix Vmatrix = Vmatrix * realmse / e(rmse)^2
ereturn post bmatrix Vmatrix, noclear
ereturn display
drop ghat gc ghc res res_c 
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m4

esttab m1 m2 m3 m4, b(%12.4f) se(%12.4f) nogap compress s(Controls Year Country N) star (* 0.1 ** 0.05 *** 0.01) drop(UrbanRate Pop IndStruct OpenFT GrpcGDP _cons)

*===============================================================================

///注释部分：一带一路样本分组回归（文章第12页第2个注释）
//OLS回归
reghdfe cepc gpr UrbanRate Pop IndStruct OpenFT GrpcGDP if 一带一路 == 1, absorb(year id) vce(robust)
reghdfe cepc gpr UrbanRate Pop IndStruct OpenFT GrpcGDP if 一带一路 == 0, absorb(year id) vce(robust)

//CF法回归
set seed 12345
// Define CF Program
capture program drop cf
program define cf
    capture drop gpr_resid
    // 1st Stage
	reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
    predict gpr_resid, resid
    // 2nd Stage
	reghdfe cepc gpr gpr_resid UrbanRate Pop IndStruct OpenFT GrpcGDP if 一带一路==0, absorb(year id) vce(robust)
end
// bootstrap the CF process
bootstrap, reps(500) seed(12345): cf

set seed 12345
// Define CF Program
capture program drop cf
program define cf
    capture drop gpr_resid
    // 1st Stage
	reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
    predict gpr_resid, resid
    // 2nd Stage
	reghdfe cepc gpr gpr_resid UrbanRate Pop IndStruct OpenFT GrpcGDP if 一带一路==1, absorb(year id) vce(robust)
end
// bootstrap the CF process
bootstrap, reps(500) seed(12345): cf

*===============================================================================

///附录表A3 主要变量的描述性统计
tabstat cepc gpr UrbanRate GrpcGDP Pop IndStruct OpenFT EnConStruct_1 EnConStruct_2 EnConStruct_3 TotEnCon TechSpillEff_FDI TechSpillEff_Trade IntRelConfl DomRelConfl, s (mean p50 sd max min ) f(%12.3f) c(s)

*===============================================================================

///附录表A4 潜在内生变量平稳性检验
xtunitroot fisher gpr, dfuller drift lags(3) demean

*===============================================================================

///附录表A5 稳健性检验I：数据源与代理指标敏感性
//附录表A5（1）-（2）列
quietly:reghdfe cepc_WDI gpr UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m1
quietly:xtivreg2 cepc_WDI (gpr = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m2
//附录表A5（3）-（4）列
quietly:reghdfe cepc gpr_h UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m3
quietly:xtivreg2 cepc (gpr_h = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m4
//附录表A5（5）-（6）列
quietly:reghdfe cepc gpr_median UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m5
quietly:xtivreg2 cepc (gpr_median = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m6
//附录表A5（7）-（8）列
quietly:reghdfe cepc ExtConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m7
quietly:xtivreg2 cepc (ExtConfl = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m8
esttab m1 m2 m3 m4 m5 m6 m7 m8, b(%12.4f) se(%12.4f) nogap compress s(Controls Year Country N) star (* 0.1 ** 0.05 *** 0.01) drop(UrbanRate Pop IndStruct OpenFT GrpcGDP _cons year2 year3 year4 year5 year6 year7 year8 year9 year10 year11 year12 year13 year14 year15 year16 year17 year18 year19 year20 year21 year22 year23 year24 year25 year26 year27 year28 year29 year30 year31 year32)

*===============================================================================

///附录表A6 稳健性检验II：样本敏感性
//APEC成员国-附录表A6（1）-（2）列
quietly:reghdfe cepc gpr UrbanRate Pop IndStruct OpenFT GrpcGDP if APEC == 1, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m1
quietly:xtivreg2 cepc (gpr = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32 if APEC == 1, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m2
//G20成员国-附录表A6（3）-（4）列
quietly:reghdfe cepc gpr UrbanRate Pop IndStruct OpenFT GrpcGDP if G20 == 1, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m3
quietly:xtivreg2 cepc (gpr = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32 if G20 == 1, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m4
//排除美国后的样本（id=37为美国）-附录表A6（5）-（6）列
quietly:reghdfe cepc gpr UrbanRate Pop IndStruct OpenFT GrpcGDP if id !=37, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m5
quietly:xtivreg2 cepc (gpr = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32 if id !=37, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m6
esttab m1 m2 m3 m4 m5 m6, b(%12.4f) se(%12.4f) nogap compress s(Controls Year Country N) star (* 0.1 ** 0.05 *** 0.01) drop(UrbanRate Pop IndStruct OpenFT GrpcGDP _cons year2 year3 year4 year5 year6 year7 year8 year9 year10 year11 year12 year13 year14 year15 year16 year17 year18 year19 year20 year21 year22 year23 year24 year25 year26 year27 year28 year29 year30 year31 year32)

*===============================================================================

///附录表A7  稳健性检验III：地缘政治风险烈度敏感性(I)
//附录表A7（1）列
quietly:reghdfe cepc gpr UrbanRate Pop IndStruct OpenFT GrpcGDP if War==0, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m1

//附录表A7（2）列
quietly:xtivreg2 cepc (gpr = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32 if War==0 , fe r
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m2

//附录表A7（3）列
quietly:reghdfe cepc gpr UrbanRate Pop IndStruct OpenFT GrpcGDP if War==1, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m3

//附录表A7（4）列
quietly:xtivreg2 cepc (gpr = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32 if War==1, fe r
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m4
esttab m1 m2 m3 m4, b(%12.4f) se(%12.4f) nogap compress s(Controls Year Country N) star (* 0.1 ** 0.05 *** 0.01) keep(gpr)

//（附录表A7注释：“组间系数差异检验的p-value为0.150”）
set seed 1234
bdiff, group(War) model (reghdfe cepc x_hat UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)) bs reps(1000) detail
// 由于War==1时样本观察较少，bootstrap抽样进行xtivreg2会报错，这里以2SLS估计代替。尽管2SLS估计值的标准误不准确，但不影响使用bootstrap检验组间差异。

// （附录表A7注释：“基于CF法gpr系数估计值的组间系数差异检验的p-value为0.148”）
//War=0时CF法检验
set seed 12345
// Define CF Program
capture program drop cf
program define cf
    capture drop gpr_resid
    // 1st Stage
	reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
    predict gpr_resid, resid
    // 2nd Stage
	reghdfe cepc gpr gpr_resid UrbanRate Pop IndStruct OpenFT GrpcGDP if War==0, absorb(year id) vce(robust)
end
// bootstrap the CF process
bootstrap, reps(500) seed(12345): cf

//War=1时CF法检验
set seed 12345
// Define CF Program
capture program drop cf
program define cf
    capture drop gpr_resid
    // 1st Stage
	reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
    predict gpr_resid, resid
    // 2nd Stage
	reghdfe cepc gpr gpr_resid UrbanRate Pop IndStruct OpenFT GrpcGDP if War==1, absorb(year id) vce(robust)
end
// bootstrap the CF process
bootstrap, reps(500) seed(12345): cf

bdiff, group(War) model (reghdfe cepc gpr  gpr_resid UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)) bs reps(500) detail

*===============================================================================

///附录表A8  稳健性检验III：地缘政治风险烈度敏感性(II)
//是否发生战争-附录表A8（1）-（2）列
quietly:reghdfe cepc gpr War UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m1
quietly:xtivreg2 cepc (gpr = IntRelConfl) War UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe r
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m2
//是否发生国际战争-附录表A8（3）-（4）列
quietly:reghdfe cepc gpr Interstate UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m3
quietly:xtivreg2 cepc (gpr = IntRelConfl) Interstate UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe r
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m4
//是否发生国内战争-附录表A8（5）-（6）列
quietly:reghdfe cepc gpr Intrastate UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m5
quietly:xtivreg2 cepc (gpr = IntRelConfl) Intrastate UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe r
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m6
//是否发生国际化内战-附录表A8（7）-（8）列
quietly:reghdfe cepc gpr Internationalized_Intrastate UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m7
quietly:xtivreg2 cepc (gpr = IntRelConfl) Internationalized_Intrastate UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe r
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m8
esttab m1 m2 m3 m4 m5 m6 m7 m8, b(%12.4f) se(%12.4f) nogap compress s(Controls Year Country N) star (* 0.1 ** 0.05 *** 0.01) keep(gpr War Interstate Intrastate Internationalized_Intrastate)

*===============================================================================

///附录表A9  稳健性检验IV：碳排放路径依赖敏感性
//附录表A9（1）列
quietly:xtivreg2 cepc (gpr = IntRelConfl) L1.cepc UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
//附录表A9（2）列
est sto m1
quietly:xtabond2 cepc L1.cepc gpr UrbanRate Pop IndStruct OpenFT GrpcGDP Year, gmm(L1.cepc gpr,lag(1 2) collapse) iv(UrbanRate Pop IndStruct OpenFT GrpcGDP Year) twostep robust
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m2
esttab m1 m2, b(%12.4f) se(%12.4f) nogap compress s(Controls Year Country N) star (* 0.1 ** 0.05 *** 0.01) drop(UrbanRate Pop IndStruct OpenFT GrpcGDP _cons Year year2 year3 year4 year5 year6 year7 year8 year9 year10 year11 year12 year13 year14 year15 year16 year17 year18 year19 year20 year21 year22 year23 year24 year25 year26 year27 year28 year29 year30 year31 year32)

*===============================================================================

///附录表A10  稳健性检验V：工具构造方法敏感性
//附录表A10（1）列
quietly:reghdfe gpr DomRelConfl_Alt UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m1
//附录表A10（2）列
quietly:xtivreg2 cepc (gpr = DomRelConfl_Alt) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m2
//附录表A10（3）列
quietly:reghdfe  gpr IntRelConfl_Alt UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m3
//附录表A10（4）列
quietly:xtivreg2 cepc (gpr = IntRelConfl_Alt) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m4
esttab m1 m2 m3 m4, b(%12.4f) se(%12.4f) nogap compress s(Controls Year Country N) star (* 0.1 ** 0.05 *** 0.01) drop(UrbanRate Pop IndStruct OpenFT GrpcGDP _cons year2 year3 year4 year5 year6 year7 year8 year9 year10 year11 year12 year13 year14 year15 year16 year17 year18 year19 year20 year21 year22 year23 year24 year25 year26 year27 year28 year29 year30 year31 year32)

*===============================================================================

///附录表A11  稳健性检验VI：地缘政治风险对国家碳排放的短期与长期影响
//gpr滞后零期-附录表A11（1）-（2）列
quietly:reghdfe cepc gpr UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m1
quietly:xtivreg2 cepc (gpr = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m2
//gpr滞后一期-附录表A11（3）-（4）列
quietly:reghdfe cepc L1.gpr UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m3
quietly:xtivreg2 cepc (L1.gpr = L1.IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m4
//gpr滞后二期-附录表A11（5）-（6）列
quietly:reghdfe cepc L2.gpr UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m5
quietly:xtivreg2 cepc (L2.gpr = L2.IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m6
//gpr滞后三期-附录表A11（7）-（8）列
quietly:reghdfe cepc L3.gpr UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m7
quietly:xtivreg2 cepc (L3.gpr = L3.IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m8
esttab m1 m2 m3 m4 m5 m6 m7 m8, b(%12.4f) se(%12.4f) nogap compress s(Controls Year Country N) star (* 0.1 ** 0.05 *** 0.01) drop(UrbanRate Pop IndStruct OpenFT GrpcGDP _cons year2 year3 year4 year5 year6 year7 year8 year9 year10 year11 year12 year13 year14 year15 year16 year17 year18 year19 year20 year21 year22 year23 year24 year25 year26 year27 year28 year29 year30 year31 year32)

*===============================================================================

///附录表A12  稳健性检验VII：门槛效应检验结果
set seed 12345
xthreg cepc UrbanRate Pop2 IndStruct OpenFT2 GrpcGDP2 year2-year32, rx(gpr) qx(gpr) thnum(3) grid(100) trim(0.05 0.05 0.05) bs(300 300 300) robust

*===============================================================================

///附录表A13  影响渠道检验：地缘政治风险分类检验 
//Panel A.  地缘政治行动的渠道检验
//附录表A13Panel A（1）-（2）列
quietly:reghdfe EnConStruct_1 gpra UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m1
quietly:xtivreg2 EnConStruct_1 (gpra = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m2
//附录表A13Panel A（3）-（4）列
quietly:reghdfe TotEnCon gpra UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m3
quietly:xtivreg2 TotEnCon (gpra = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m4
//附录表A13Panel A（5）-（6）列
quietly:reghdfe TechSpillEff_FDI gpra UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m5
quietly:xtivreg2 TechSpillEff_FDI (gpra = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m6
//附录表A13Panel A（7）-（8）列
quietly:reghdfe TechSpillEff_Trade gpra UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m7
quietly:xtivreg2 TechSpillEff_Trade (gpra = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m8
esttab m1 m2 m3 m4 m5 m6 m7 m8, b(%12.4f) se(%12.4f) nogap compress s(Controls Year Country N) star (* 0.1 ** 0.05 *** 0.01) drop(UrbanRate Pop IndStruct OpenFT GrpcGDP _cons year2 year3 year4 year5 year6 year7 year8 year9 year10 year11 year12 year13 year14 year15 year16 year17 year18 year19 year20 year21 year22 year23 year24 year25 year26 year27 year28 year29 year30 year31 year32)

//Panel B.  地缘政治威胁的渠道检验
//附录表A13Panel B（9）-（10）列
quietly:reghdfe EnConStruct_1 gprt UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m1
quietly:xtivreg2 EnConStruct_1 (gprt = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m2
//附录表A13Panel B（11）-（12）列
quietly:reghdfe TotEnCon gprt UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m3
quietly:xtivreg2 TotEnCon (gprt = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m4
//附录表A13Panel B（13）-（14）列
quietly:reghdfe TechSpillEff_FDI gprt UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m5
quietly:xtivreg2 TechSpillEff_FDI (gprt = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m6
//附录表A13Panel B（15）-（16）列
quietly:reghdfe TechSpillEff_Trade gprt UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m7
quietly:xtivreg2 TechSpillEff_Trade (gprt = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m8
esttab m1 m2 m3 m4 m5 m6 m7 m8, b(%12.4f) se(%12.4f) nogap compress s(Controls Year Country N) star (* 0.1 ** 0.05 *** 0.01) drop(UrbanRate Pop IndStruct OpenFT GrpcGDP _cons year2 year3 year4 year5 year6 year7 year8 year9 year10 year11 year12 year13 year14 year15 year16 year17 year18 year19 year20 year21 year22 year23 year24 year25 year26 year27 year28 year29 year30 year31 year32)

*===============================================================================

///附录表A14 基准回归：地缘政治风险分类检验
//附录表A14（1）列
quietly:reghdfe cepc gpra UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m1
//附录表A14（1）列
quietly:xtivreg2 cepc (gpra = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m2
//附录表A14（1）列
quietly:reghdfe cepc gprt UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m3
//附录表A14（1）列
quietly:xtivreg2 cepc (gprt = IntRelConfl) UrbanRate Pop IndStruct OpenFT GrpcGDP year2-year32, fe robust first
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m4
esttab m1 m2 m3 m4, b(%12.4f) se(%12.4f) nogap compress s(Controls Year Country N) star (* 0.1 ** 0.05 *** 0.01) drop(UrbanRate Pop IndStruct OpenFT GrpcGDP _cons year2 year3 year4 year5 year6 year7 year8 year9 year10 year11 year12 year13 year14 year15 year16 year17 year18 year19 year20 year21 year22 year23 year24 year25 year26 year27 year28 year29 year30 year31 year32)

*===============================================================================

///附录表A15  地缘政治风险背景下的减碳路径检验
//附录表A15（1）列
quietly:reghdfe cepc gpr gprxHumCap5 UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m1

//附录表A15（2）列
* Raw 2nd Stage Regression
quietly:reghdfe cepc x_hat x_hatxHumCap5 UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
matrix bmatrix = e(b)
matrix Vmatrix = e(V)
* Manually Adjusted SE's
quietly:reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
predict double ghat, xbd
gen gc = gpr * HumCap5
gen ghc = ghat * HumCap5
quietly: reghdfe cepc ghat ghc UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
predict double res, residual
gen res_c = res + (_b[ghat]*ghat-_b[ghat]*gpr) + (_b[ghc]*ghc-_b[ghc]*gc)
replace res_c = res_c^2
quietly:su res_c
scalar realmse = r(mean)*r(N)/e(df_r)
matrix Vmatrix = Vmatrix * realmse / e(rmse)^2
ereturn post bmatrix Vmatrix, noclear
ereturn display
drop ghat gc ghc res res_c 
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m2

//附录表A15（3）列
quietly:reghdfe cepc gpr gprxInnov1 UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m3

//附录表A15（4）列
* Raw 2nd Stage Regression
quietly:reghdfe cepc x_hat x_hatxInnov1 UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
matrix bmatrix = e(b)
matrix Vmatrix = e(V)
* Manually Adjusted SE's
quietly:reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
predict double ghat, xbd
gen gc = gpr * Innov1
gen ghc = ghat * Innov1
quietly: reghdfe cepc ghat ghc UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
predict double res, residual
gen res_c = res + (_b[ghat]*ghat-_b[ghat]*gpr) + (_b[ghc]*ghc-_b[ghc]*gc)
replace res_c = res_c^2
quietly:su res_c
scalar realmse = r(mean)*r(N)/e(df_r)
matrix Vmatrix = Vmatrix * realmse / e(rmse)^2
ereturn post bmatrix Vmatrix, noclear
ereturn display
drop ghat gc ghc res res_c 
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m4

//附录表A15（5）列
quietly:reghdfe cepc gpr gprxIndStruct2 UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m5

//附录表A15（6）列
* Raw 2nd Stage Regression
quietly:reghdfe cepc x_hat x_hatxIndStruct2 UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
matrix bmatrix = e(b)
matrix Vmatrix = e(V)
* Manually Adjusted SE's
quietly:reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
predict double ghat, xbd
gen gc = gpr * IndStruct2
gen ghc = ghat * IndStruct2
quietly: reghdfe cepc ghat ghc UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
predict double res, residual
gen res_c = res + (_b[ghat]*ghat-_b[ghat]*gpr) + (_b[ghc]*ghc-_b[ghc]*gc)
replace res_c = res_c^2
quietly:su res_c
scalar realmse = r(mean)*r(N)/e(df_r)
matrix Vmatrix = Vmatrix * realmse / e(rmse)^2
ereturn post bmatrix Vmatrix, noclear
ereturn display
drop ghat gc ghc res res_c 
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m6

//附录表A15（7）列
quietly:reghdfe cepc gpr gprxIntcoop2 UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m7

//附录表A15（8）列
* Raw 2nd Stage Regression
quietly:reghdfe cepc x_hat x_hatxIntcoop2 UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
matrix bmatrix = e(b)
matrix Vmatrix = e(V)
* Manually Adjusted SE's
quietly:reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
predict double ghat, xbd
gen gc = gpr * Intcoop2
gen ghc = ghat * Intcoop2
quietly: reghdfe cepc ghat ghc UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
predict double res, residual
gen res_c = res + (_b[ghat]*ghat-_b[ghat]*gpr) + (_b[ghc]*ghc-_b[ghc]*gc)
replace res_c = res_c^2
quietly:su res_c
scalar realmse = r(mean)*r(N)/e(df_r)
matrix Vmatrix = Vmatrix * realmse / e(rmse)^2
ereturn post bmatrix Vmatrix, noclear
ereturn display
drop ghat gc ghc res res_c 
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m8

esttab m1 m2 m3 m4 m5 m6 m7 m8, b(%12.4f) se(%12.4f) nogap compress s(Controls Year Country N) star (* 0.1 ** 0.05 *** 0.01) drop(UrbanRate Pop IndStruct OpenFT GrpcGDP _cons)

*===============================================================================

//附录表A16 CF法
//Panel A.
//附录表A16Panel A（1）列
set seed 12345
// Define CF Program
capture program drop cf
program define cf
    capture drop gpr_resid
    // 1st Stage
	reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
    predict gpr_resid, resid
    // 2nd Stage
	reghdfe cepc gpr gprxNatResRent gpr_resid UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
end
// bootstrap the CF process
bootstrap, reps(500) seed(12345): cf
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m1

//附录表A16Panel A（2）列
set seed 12345
// Define CF Program
capture program drop cf
program define cf
    capture drop gpr_resid
    // 1st Stage
	reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
    predict gpr_resid, resid
    // 2nd Stage
	reghdfe cepc gpr gprxCoalOilRent gpr_resid UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
end
// bootstrap the CF process
bootstrap, reps(500) seed(12345): cf
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m2

//附录表A16Panel A（3）列
set seed 12345
// Define CF Program
capture program drop cf
program define cf
    capture drop gpr_resid
    // 1st Stage
	reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
    predict gpr_resid, resid
    // 2nd Stage
	reghdfe cepc gpr gprxHumCap4 gpr_resid UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
end
// 使用 bootstrap 执行 cf 程序
bootstrap, reps(500) seed(12345): cf
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m3

//附录表A16Panel A（4）列
set seed 12345
// Define CF Program
capture program drop cf
program define cf
    capture drop gpr_resid
    // 1st Stage
	reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
    predict gpr_resid, resid
    // 2nd Stage
	reghdfe cepc gpr gprxHumCap5 gpr_resid UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
end
// bootstrap the CF process
bootstrap, reps(500) seed(12345): cf
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m4

//附录表A16Panel A（5）列
set seed 12345
// Define CF Program
capture program drop cf
program define cf
    capture drop gpr_resid
    // 1st Stage
	reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
    predict gpr_resid, resid
    // 2nd Stage
	reghdfe cepc gpr gprxInnov0 gpr_resid UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
end
// bootstrap the CF process
bootstrap, reps(500) seed(12345): cf
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m5

//附录表A16Panel A（6）列
set seed 12345
// Define CF Program
capture program drop cf
program define cf
    capture drop gpr_resid
    // 1st Stage
	reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
    predict gpr_resid, resid
    // 2nd Stage
	reghdfe cepc gpr gprxInnov1 gpr_resid UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
end
// bootstrap the CF process
bootstrap, reps(500) seed(12345): cf
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m6

esttab m1 m2 m3 m4 m5 m6, b(%12.4f) se(%12.4f) nogap compress s(Controls Year Country N) star (* 0.1 ** 0.05 *** 0.01) drop(gpr_resid UrbanRate Pop IndStruct OpenFT GrpcGDP _cons)

//Panel B
//附录表A16Panel B（7）列
set seed 12345
// Define CF Program
capture program drop cf
program define cf
    capture drop gpr_resid
    // 1st Stage
	reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
    predict gpr_resid, resid
    // 2nd Stage
	reghdfe cepc gpr gprxIndStruct1 gpr_resid UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
end
// bootstrap the CF process
bootstrap, reps(500) seed(12345): cf
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m7

//附录表A16Panel B（8）列
set seed 12345
// Define CF Program
capture program drop cf
program define cf
    capture drop gpr_resid
    // 1st Stage
	reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
    predict gpr_resid, resid
    // 2nd Stage
	reghdfe cepc gpr gprxIndStruct2 gpr_resid UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
end
// bootstrap the CF process
bootstrap, reps(500) seed(12345): cf
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m8 

//附录表A16Panel B（9）列 
set seed 12345
// Define CF Program
capture program drop cf
program define cf
    capture drop gpr_resid
    // 1st Stage
	reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
    predict gpr_resid, resid
    // 2nd Stage
	reghdfe cepc gpr gprxIntcoop1 gpr_resid UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
end
// bootstrap the CF process
bootstrap, reps(500) seed(12345): cf
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m9 

//附录表A16Panel B（10）列 
set seed 12345
// Define CF Program
capture program drop cf
program define cf
    capture drop gpr_resid
    // 1st Stage
	reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
    predict gpr_resid, resid
    // 2nd Stage
	reghdfe cepc gpr gprxIntcoop2 gpr_resid UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust)
end
// bootstrap the CF process
bootstrap, reps(500) seed(12345): cf
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m10

//附录表A16Panel B（11）列 
set seed 12345
// Define CF Program
capture program drop cf
program define cf
    capture drop gpr_resid
    // 1st Stage
	reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
    predict gpr_resid, resid
    // 2nd Stage
	reghdfe cepc gpr gpr_resid UrbanRate Pop IndStruct OpenFT GrpcGDP if War==0, absorb(year id) vce(robust)
end
// bootstrap the CF process
bootstrap, reps(500) seed(12345): cf
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m11

//附录表A16Panel B（12）列 
set seed 12345
// Define CF Program
capture program drop cf
program define cf
    capture drop gpr_resid
    // 1st Stage
	reghdfe gpr IntRelConfl UrbanRate Pop IndStruct OpenFT GrpcGDP, absorb(year id) vce(robust) res
    predict gpr_resid, resid
    // 2nd Stage
	reghdfe cepc gpr gpr_resid UrbanRate Pop IndStruct OpenFT GrpcGDP if War==1, absorb(year id) vce(robust)
end
// bootstrap the CF process
bootstrap, reps(500) seed(12345): cf
estadd local Controls "Yes"
estadd local Year "Yes"
estadd local Country "Yes"
est sto m12

esttab m7 m8 m9 m10 m11 m12, b(%12.4f) se(%12.4f) nogap compress s(Controls Year Country N) star (* 0.1 ** 0.05 *** 0.01) drop(gpr_resid UrbanRate Pop IndStruct OpenFT GrpcGDP _cons)

